function [ E ] = edgemap( I )
%EDGEMAP Summary of this function goes here
%   Detailed explanation goes here

persistent model;

if(isempty(model))
    %% set opts for training (see edgesTrain.m)
%     opts=edgesTrain();                % default options (good settings)
    opts.modelDir='edgemap/models/';          % model will be in models/forest
    opts.modelFnm='modelBsds_sharp4_trainval';        % model name
%     opts.nPos=5e5; opts.nNeg=5e5;     % decrease to speedup training
%     opts.useParfor=0;                 % parallelize if sufficient memory
    
    %% train edge detector (~20m/8Gb per tree, proportional to nPos/nNeg)
    model=edgesTrain(opts); % will load model if already trained
    
%     %% set detection parameters (can set after training)
%     model.opts.stride = 3;
    model.opts.multiscale=0;          % for top accuracy set multiscale=1
    model.opts.sharpen=4;             % for top speed set sharpen=0
    model.opts.nTreesEval=1;          % for top speed set nTreesEval=1
    model.opts.nThreads=1;            % max number threads for evaluation
    model.opts.nms=0;                 % set to true to enable nms
end

%% detect edge and visualize results
E=edgesDetect(I,model);

end

