function [recall, precision, blength] = boundary_measure(groundTruth, prediction)

%%
E = 2;
recall = zeros(length(groundTruth), length(prediction));
precision = zeros(length(groundTruth), length(prediction));
blength = zeros(1, length(prediction));

[height, width] = size(groundTruth{1}.Boundaries);

for k_i = 1:length(prediction)
    P = reshape(prediction{k_i}.Boundaries, height,width);
    blength(k_i) = sum(sum(P));
    
    if(E>0), P_ = logical(conv2(double(P),fspecial('disk',E),'same')); else P_ = P; end
    
    for gt_i = 1:length(groundTruth)
        G = groundTruth{gt_i}.Boundaries;
        if(E>0), G_ = logical(conv2(double(G),fspecial('disk',E),'same')); else G_ = G; end
        
        overlap_G = sum(sum(G & P_));
        overlap_P = sum(sum(G_ & P));
        recall(gt_i,k_i) = overlap_G / sum(sum(G));
        precision(gt_i,k_i) = overlap_P / blength(k_i);
    end
end
