function accuracy = segmentation_accuracy(groundTruth, prediction)

%%
accuracy = zeros(length(groundTruth), length(prediction));
for k_i = 1:length(prediction)
	P = prediction{k_i}.Segmentation(:);
	N_P_overlap_max = zeros(max(P), 1);
	for gt_i = 1:length(groundTruth)
		G = groundTruth{gt_i}.Segmentation(:);
		for i = 1:max(G)
			P_overlap = P(G == i);
			K_P_overlap = unique(P_overlap);
			N_P_overlap = histc(P_overlap, K_P_overlap);
			N_P_overlap_max(K_P_overlap) = max(N_P_overlap_max(K_P_overlap), N_P_overlap);
		end
		accuracy(gt_i,k_i) = sum(N_P_overlap_max);
	end
end
N = length(groundTruth{1}.Segmentation(:));
accuracy = accuracy / N;