function error = undersegmentation_error(groundTruth, prediction)

%%
B = 0.05;
error = zeros(length(groundTruth), length(prediction));

for k_i = 1:length(prediction)
	P = prediction{k_i}.Segmentation(:);
	N_P = histc(P, 1:max(P));
	for gt_i = 1:length(groundTruth)
		G = groundTruth{gt_i}.Segmentation(:);
		for i = 1:max(G)
			P_overlap = P(G == i);
			K_P_overlap = unique(P_overlap);
			N_P_overlap = histc(P_overlap, K_P_overlap);
            N_P_overlap_seg = N_P(K_P_overlap);
            error(gt_i,k_i) = error(gt_i,k_i) + sum(N_P_overlap_seg(N_P_overlap > B*N_P_overlap_seg)-N_P_overlap(N_P_overlap > B*N_P_overlap_seg));
		end
	end
end
N = length(groundTruth{1}.Segmentation(:));

% error = error/N;
error = error / N;