function [time, K] = run_on_benchmark(method, imgpath, outpath)

if imgpath(end) ~= '/'
	imgpath(end+1) = '/';
end
if outpath(end) ~= '/'
	outpath(end+1) = '/';
end

if(~exist(outpath,'dir')), mkdir(outpath); end

images = dir([imgpath '*.jpg']);

% K_given = [600 500 400 300 200 150 100 50 25 12 9 6];
K_given = [800 600 500 400 300 200 150 100 50 25];

time = zeros(length(images), length(K_given));
K = zeros(length(images), length(K_given));
prediction = cell(1,length(K_given));

disp(['*** ' func2str(method) ' ***']);
for i = 1:length(images)
	disp(['  Image ' num2str(i)]);
	imgname = images(i).name(1:end-4);
	for j = 1:length(K_given)
        [Y, bmap, K_j, time_j] = method([imgpath imgname '.jpg'], K_given(j));
		prediction{j}.Segmentation = Y;
		prediction{j}.Boundaries = bmap;
		prediction{j}.Time = time_j;
		prediction{j}.K = K_j;
		time(i,j) = time_j;
		K(i,j) = K_j;
	end
	save([outpath imgname '.mat'], 'prediction');
end
