function [] = superpixel_test()

saveFlag = true;

imgDir = '../BSR/BSDS500/data/images/test/';
images = dir([imgDir '*.jpg']);
resultdir = 'image_result/';

k_list = [50, 200];
for i=1:length(images)
    
    disp(images(i).name);
    
    imgpath = [imgDir images(i).name];
    img = imread(imgpath);
    figure(1), imshow(img,'initialmagnification','fit');
    
    imgId = images(i).name(1:end-4);
    savedir = [resultdir imgId '/'];
    if (~exist(savedir, 'dir'))
        mkdir(savedir);
    end
    if(saveFlag), imwrite(img,[savedir 'original.jpg'],'jpg'); end
    
    for k=k_list
        figure(2);
        
        Y = mmlp_superpixel(imgpath, k);
        bmap = logical(seg2bdry(Y,'imageSize',true));
        bmaponimg = bmapOnImg(img, bmap);
        imshow(bmaponimg);
        title('MMLP');
        if(saveFlag), imwrite(bmaponimg,[savedir num2str(k) '_mmlp.jpg'],'jpg'); end
        
%         ginput(1);
        pause(0.001);
    end
end


function res = evaluate(groundTruth, prediction)
error = undersegmentation_error(groundTruth, prediction);
[recall, precision, blength] = boundary_measure(groundTruth, prediction);
accuracy = segmentation_accuracy(groundTruth, prediction);

res.error = mean(error);
res.recall = mean(recall);
res.precision = mean(precision);
res.blength = mean(blength);
res.accuracy = mean(accuracy);
res.F = 1/(1/res.recall+1/res.precision);